; Sample Program
; Copyright  2014 Larry Charlton

	option casemap:none

	.nolist
	.nocref
WIN32_LEAN_AND_MEAN equ 1
	include	windows.inc
	.list
	.cref

	includelib <kernel32.lib>
	includelib <user32.lib>

OUTMODE	equ	(ENABLE_PROCESSED_OUTPUT or ENABLE_WRAP_AT_EOL_OUTPUT)

.code
@con_show proc uses rbx rsi rdi, pText:QWORD 
 local	consoleoutoriginal	:qword
 local	charswritten	:qword
 	mov	pText, rcx					; save parameter to shadow store
	invoke	GetStdHandle,STD_OUTPUT_HANDLE			; get stdout
	mov	rsi, rax						; keep in rsi
	invoke	GetConsoleMode, rsi, addr consoleoutoriginal		; save console mode to original console out mode
	mov	rdx, OUTMODE					; rdx = OUTMODE
	cmp	rdx, consoleoutoriginal				; if OUTMODE!=original console out mode
	jz	@con_show1
	invoke	SetConsoleMode, rsi, edx				; set console mode to our value
@con_show1:	
	mov	rdi, pText					; lstrlen requires wide strings
	xor	rdx, rdx
@con_show3:
	mov	al, [rdi+rdx]
	or	al, al
	jz	@con_show4
	inc	rdx
	jmp	@con_show3
@con_show4:
	mov	rax, rdx
	invoke	WriteConsoleA, rsi, pText, eax, addr charswritten, 0	; write message to screen
	mov	rdx, consoleoutoriginal				; get original console out mode
	cmp	rdx, OUTMODE					; if original console out mode != OUTMODE
	jnz	@con_show2
	invoke	SetConsoleMode, rsi, edx				; set console mode back
@con_show2:	
	xor	rax, rax						; 0 return value
	ret
@con_show endp
	end
